#ifndef __PLUGIN__
#define __PLUGIN__

#ifdef __cplusplus
extern "C" {
#endif

#include <X11/Xlib.h>
#include "font.h"
#include "options.h"

#define INIT_SYM "Init"

typedef struct _tagPANELINFO
{
  Window wnd;
  const char *name;
} PANELINFO,*LPPANELINFO;

struct _tagMODULE;

typedef void (*MODULE_EVENTHANDLER)(struct _tagMODULE *,XEvent *pEvent);
typedef void (*MODULE_DESTROY)(struct _tagMODULE *);
typedef void (*MODULE_TIMEOUT)(struct _tagMODULE *);
typedef const char *(*MODULE_GETTOOLTIP)(struct _tagMODULE *);

typedef struct _tagMODULE
{
  MODULE_EVENTHANDLER EventHandler;
  MODULE_DESTROY      Destroy;
  MODULE_TIMEOUT      Timeout;
  MODULE_GETTOOLTIP   GetTooltip;
  int numPanels;
  PANELINFO panels[1];
} MODULE,*LPMODULE;

typedef struct _tagLIBRARYINIT
{
  /* in */
  Display *pDisplay;
  int screen;
  Window root;
  Window panelWindow;
  unsigned long backgroundPixel;
  unsigned int height;
  unsigned int baseInputMask;
  LPFONT pFont;
  LPCONFIGITEM pOptions;
  /* out */
  LPMODULE pModule;
} LIBRARYINIT,*LPLIBRARYINIT;

/* Plugins must implement this function and set the out parameter *pModule
   in the LPLIBRARYINIT structure.  Return non-zero on success, 0 on failure.
*/
typedef int (*LIBINIT)(LPLIBRARYINIT pInit);

#ifdef __cplusplus
}
#endif
#endif

